for x in /dev/md/* ; do
	mdadm --stop $x
done

for disk in $(list-devices disk); do
	wipefs -a /dev/$disk[p][0-9]
	wipefs -a /dev/$disk
	mdadm --zero-superblock /dev/$disk
	dd if=/dev/zero of=/dev/$disk bs=512 count=32
	blkdiscard --secure /dev/${disk}
	parted -s /dev/${disk} mklabel gpt;
	partprobe
done

for x in /dev/md[0-9]* ; do
	mdadm --stop $x
done

if grep -q QEMU /proc/cpuinfo || dmesg | grep -q 'Manufacturer: QEMU' ; then
	export WITHOUT_SWAP=yes
fi
sleep 2
list-devices disk | tr '\n' ' ' > /tmp/list-devices
read DISKA DISKB < /tmp/list-devices
SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5)
MBR_LIMIT=2000000000000
debconf-set partman-basicfilesystems/choose_label gpt
debconf-set partman-basicfilesystems/default_label gpt
debconf-set partman-partitioning/choose_label gpt
debconf-set partman-partitioning/default_label gpt
debconf-set partman/choose_label gpt
debconf-set partman/default_label gpt
if [ -d /sys/firmware/efi ]; then \
	debconf-set partman-efi/non_efi_system true
fi
debconf-set partman-auto/disk "${DISKA}"
debconf-set partman-auto/method "regular"
BOOT_DSIZE=$(parted -sm ${DISKA} unit GB print | grep -e "${DISKA}" | cut -d: -f2 | sed -e 's/GB$//' | cut -d. -f1) 
if [ -z "${BOOT_DSIZE}" ]; then BOOT_DSIZE=0 ; fi
BOOT_LIMIT=3000
if [ ${BOOT_DSIZE} -ge ${BOOT_LIMIT} ]; then
	WITH_BOOT=yes
fi
bootsize=256
if [ -n "${WITHOUT_SWAP}" ]; then
	debconf-set partman-auto/expert_recipe "boot-root :: \
		1 1 1 free \$gptonly{ } \$primary{ } \$bios_boot{ } method{ biosgrub } . \
		$(test -n "${WITH_BOOT}" && echo "${bootsize} 50 ${bootsize} ext2 \$primary{ } \$bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } .") \
		1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . "
else
	if [ -d /sys/firmware/efi ]; then
		debconf-set partman-auto/expert_recipe "boot-root :: \
		300 200 500 free \$iflabel{ gpt } \$reusemethod{ } method{ efi } format{ } . \
		$(test -n "${WITH_BOOT}" && echo "${bootsize} 50 ${bootsize} ext2 \$primary{ } \$bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } .") \
		128 512 100% linux-swap method{ swap } format{ } . \
		1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . "
	else
		debconf-set partman-auto/expert_recipe "boot-root :: \
		1 1 1 free \$gptonly{ } \$primary{ } \$bios_boot{ } method{ biosgrub } . \
		$(test -n "${WITH_BOOT}" && echo "${bootsize} 50 ${bootsize} ext2 \$primary{ } \$bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } .") \
		128 512 100% linux-swap method{ swap } format{ } . \
		1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . "
	fi
fi
debconf-set grub-installer/bootdev "${DISKA}"
